/***************************** VOD MEDIA FUNCTIONS *****************************/
function clearMedia(fx) {
	logConsole("In clearMedia...");

	if(isVODPlaying()){
		try{
			//media = getMediaFromStoredParams();
            //setBackgroundToBlack();
            //SyncBackgroundSettingsToParent("portal");

			media.stop({
				"onSuccess":function() {
					media.destroy({
						"onSuccess":function() {
							hcap.Media.shutDown({
								"onSuccess":function() {
									expireCookie("vod_playing");
									expireCookie("vod_idx");
									setCookie("portal_mode", PORTAL_MODE_TV, COOKIE_EXPIRE_DAYS);

									if(typeof fx === "function") {
										fx();
									}
								},
								"onFailure":function(f) {
									logConsole("109onFailure : errorMessage = " + f.errorMessage);
								}
							});
						},
						"onFailure":function(f) {
							logConsole("149 onFailure : errorMessage = " + f.errorMessage);
						}
					});
				},
				"onFailure":function(f) {
					logConsole("onFailure : errorMessage = " + f.errorMessage);
				}
			});
		}
		catch(err){
		   	logConsole ("121 HCAP ERROR " + err);
		}
	}
}

function clearVODStatus(fx) {
    logConsole("In clearVODStatus...");

    if(isVODPlaying()){
        try{
            hcap.Media.shutDown({
                "onSuccess":function() {
                    expireCookie("vod_playing");
                    expireCookie("vod_idx");
                    setCookie("portal_mode", PORTAL_MODE_TV, COOKIE_EXPIRE_DAYS);

                    if(typeof fx === "function") {
                        fx();
                    }
                },
                "onFailure":function(f) {
                    logConsole("109onFailure : errorMessage = " + f.errorMessage);
                }
            });
        }
        catch(err){
            logConsole ("121 HCAP ERROR " + err);
        }
    }
}

function getMediaState() {
	media.getState({
		"onSuccess" : function(s) {
			logConsole("onSuccess state : " + s.state);
		},
		"onFailure" : function(f) {
			logConsole("onFailure : errorMessage = " + f.errorMessage);
		}
	});
}

function getMediaPosition(media) {
	media.getPlayPosition({
		"onSuccess" : function(s) {
			logConsole("onSuccess position : " + s.positionInMs);
		},
		"onFailure" : function(f) {
			logConsole("onFailure : errorMessage = " + f.errorMessage);
		}
	});
}

function mediaPlay(video_url, is_encrypted, Protocal) {
	logConsole("In mediaPlay: " + video_url + ", " + is_encrypted + ", " + Protocal);
	//parsem3u8("prog_index.m3u8");

	var mediaParams = {};

	if(is_encrypted == "true"){
		session_id = getCookie('session_id');

		logConsole("Encrypted file - session_id: " + session_id);
		mediaParams.drmType = "PROIDIOM";
		mediaParams.sessionId = session_id;
	}

	mediaParams.url = video_url;
	mediaParams.mimeType = "video/mpeg";
	RWJump = 10000;

	logConsole("About to hcap.Media.startUp...");
	localStorage.setItem("mediaParams", JSON.stringify(mediaParams));
	try {
		hcap.Media.startUp({
			"onSuccess":function() {
				logConsole("Startup onSuccess");
				media = new hcap.Media.createMedia(mediaParams);
				media.play({
					"onSuccess":function() {
						logConsole("Play onSuccess");
					},
					"onFailure":function(f) {
						logConsole("line 65 onFailure : errorMessage = " + f.errorMessage);
                        clearVODStatus(function() {
                            goToReferrerPage(true);
						});
					}
				});
			},
			"onFailure":function(f) {
				 logConsole("hcap.Media.startUp onFailure : errorMessage = " + f.errorMessage);
			}
		});
	}
	catch(err) {
		logConsole("ERROR: " + err);
	}
}

function parsem3u8(url){
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.onreadystatechange = function(){
		if(xmlhttp.status==200 && xmlhttp.readyState==4){
		  var words = xmlhttp.responseText;

			str = words.substring(words.indexOf("#EXTINF:")+8,words.length);
			FFjump = parseInt(str.substring(0,str.indexOf(","))) * 1000;
		}
	}
	xmlhttp.open("GET",url,true);
	xmlhttp.send();
}

function mediaPlayPause(){
	if(isVODPlaying()){
  		mediaPause();
	}else{
		mediaResume();
	}
}

function getMediaFromStoredParams() {
	mediaParams = localStorage.getItem("mediaParams");
	logConsole("mediaParams: " + mediaParams);

	if (typeof mediaParams !== 'undefined' && mediaParams != '') {
		mediaParams = JSON.parse(mediaParams);
	}
	else {
		mediaParams = {};
	}

	media = new hcap.Media.createMedia(mediaParams);

	return media;
}

function mediaPause() {
	logConsole("In mediaPause...");
	try {
		//media = getMediaFromStoredParams();
		media.pause({
			 "onSuccess":function() {
				 logConsole("onSuccess Pause");
			 },
			 "onFailure":function(f) {
				 logConsole("192onFailure : errorMessage = " + f.errorMessage);
			 }
		 });
	}
	catch(err) {
		logConsole("ERROR: " + err);
	}
}

function mediaResume() {
	logConsole("In mediaResume...");
	try {
		//media = getMediaFromStoredParams();
		media.resume({
			 "onSuccess":function() {
				 logConsole("Resume onSuccess");
			 },
			 "onFailure":function(f) {
				 logConsole("Resume onFailure : errorMessage = " + f.errorMessage);
			 }
		 });
	}
	catch(err) {
		logConsole("ERROR: " + err);
	}
}

function mediaRewind() {
	media.getPlayPosition({
		"onSuccess":function(s) {
					var x = (parseInt(s.positionInMs)-RWJump)
		  x = Math.floor(x / 10000) * 10000;
					media.setPlayPosition({
				 "positionInMs":x,
			 "onSuccess":function() {
			   logConsole("onSuccess");
			  },
			  "onFailure":function(f) {
				 logConsole("onFailure : errorMessage = " + f.errorMessage);
			  }
    	 });
  	},
 		"onFailure":function(f) {    	logConsole("225onFailure : errorMessage = " + f.errorMessage);  	}
  });
}

function mediaFastForward(FFJump) {
	media.getPlayPosition({
		"onSuccess":function(s) {
			 var x = (parseInt(s.positionInMs)+FFJump)
			 x = Math.ceil(x / 10000) * 10000;
			 media.setPlayPosition({
				  "positionInMs": x,
				  "onSuccess":function() {
				  	logConsole("onSuccess " + s.positionInMs + " : " + FFJump + " = " + x);
				  },
				  "onFailure":function(f) {
				  	logConsole("onFailure : errorMessage = " + f.errorMessage);
				  }
		 	 });
		},
		"onFailure":function(f) {
			logConsole("225onFailure : errorMessage = " + f.errorMessage);
		}
	});
}
/***************************** VOD MEDIA FUNCTIONS *****************************/