var softapHandler = (function($, _){
    function softapSync(){
        requestHandler.requestAPI('GET', "/api/v2/rooms/" + localStorage.getItem("room_number"), '', function(result) {
            if (result.status !== "success"){
                return;
            }
            var tvIp = localStorage.getItem("tv_ip_address");
            var roomId = localStorage.getItem("room_number");
            result.data.tvs.forEach(function(element){
                if (element.ip === tvIp){
                    var softapInfo = {
                        ssid : roomId,
                        mode : (element.softApMode === 1 ? "ON" : "OFF"),
                        pwd : element.softApPassword 
                    };
                    if (softapInfo.mode === "ON"){
                        setSoftAP(softapInfo.ssid, softapInfo.pwd);
                        setSoftAPInfo(softapInfo);
                    }
                    else{
                        unsetSoftap();
                        localStorage.removeItem("softap");
                    }        
                }
            });
        });
    }

    function setSoftAP(ssid, pwd){
        return hcapPromise.property.setProperty({
            "key" : "soft_ap_ui",
            "value" : "1",
            "onSuccess" : function() {
                console.log("onSuccess");
            },
            "onFailure" : function(f) {
                console.log("onFailure : errorMessage = " + f.errorMessage);
            }
        }).then(function(){
            return hcapPromise.property.setProperty({
                "key" : "soft_ap",
                "value" : "1",
                "onSuccess" : function() {
                    console.log("onSuccess");
                },
                "onFailure" : function(f) {
                    console.log("onFailure : errorMessage = " + f.errorMessage);
                }
            });
        })
        .then(function(){
            return hcapPromise.property.setProperty({
                "key" : "soft_ap_password",
                "value" : pwd,
                "onSuccess" : function() {
                    console.log("onSuccess");
                    getIframeObject().updateWidgets();
                },
                "onFailure" : function(f) {
                    console.log("onFailure : errorMessage = " + f.errorMessage);
                }
            });
        });
    }
    
    function unsetSoftAP(){
        return hcapPromise.property.setProperty({
            "key" : "soft_ap",
            "value" : "0",
            "onSuccess" : function() {
                console.log("onSuccess");
                getIframeObject().updateWidgets();
            },
            "onFailure" : function(f) {
                console.log("onFailure : errorMessage = " + f.errorMessage);
            }
        });
    }
    
    function setSoftAPInfo(softapInfo){
        return hcapPromise.property.getProperty({
            "key" : "tv_name",
            "onSuccess" : function(s) {
                softapInfo.ssid = s.value;
                localStorage.setItem("softap", JSON.stringify(softapInfo));
                console.log("onSuccess : property value = " + s.value);
            },
            "onFailure" : function(f) {
                console.log("onFailure : errorMessage = " + f.errorMessage);
            }
        });
    }
    return {
        softapSync: softapSync,
        setSoftAP: setSoftAP,
        unsetSoftAP: unsetSoftAP,
        setSoftAPInfo: setSoftAPInfo
    };
})(jQuery, _);